//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadSecurityDll()
{
	m_hinstLib = LoadLibrary("pdfsecurity.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMDecryptPDF = (MDecryptPDF *)GetProcAddress(m_hinstLib, "MDecryptPDF");
	if( pMDecryptPDF == NULL ){ 
		FreeSecurityDll(); 
		return FALSE;
	}

	pMEncryptPDF = (MEncryptPDF *)GetProcAddress(m_hinstLib, "MEncryptPDF");
	if( pMEncryptPDF == NULL ){ 
		FreeSecurityDll(); 
		return FALSE;
	}
	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreeSecurityDll();
		return FALSE;
	}

	pMInformation = (MInformation *)GetProcAddress(m_hinstLib, "MInformation");
	if( pMInformation == NULL ){ 
		FreeSecurityDll();
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreeSecurityDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreeSecurityDll(); 
		return FALSE;
	}
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreeSecurityDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadSecurityDll() == FALSE ){
		ShowMessage("Load pdfsecurity.dll failed!");
		return;
	}

	char inFile[256];	
	char outFile[256];

	long id = pMBegin();
	if(id>0){
		//Set PDF Information
		pMInformation(id,"title","subject","author","keywords","creator","producer");

		long fsize=16;
		long fcolor=255;//red
		long position=2;//Top-Center
		long angle=0;
		long xoff=0;
		long yoff=0;
        long asbackground=0;
		//Stamping
		pMWatermark(id,"Watermark",fsize,fcolor,position,angle,xoff,yoff,asbackground);

		//test1 Decrypt
		strcpy(inFile,"test1.pdf");
		strcpy(outFile,"test1Decrypt.pdf");
		pMDecryptPDF(id,inFile,outFile,"user","owner");

		//test2 Decrypt
		strcpy(inFile,"test2.pdf");
		strcpy(outFile,"test2Decrypt.pdf");
		pMDecryptPDF(id,inFile,outFile,"","");

		pMEnd(id);
	}	

	FreeSecurityDll();
	ShowMessage("Decrypt finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadSecurityDll() == FALSE ){
		ShowMessage("Load pdfsecurity.dll failed!");
		return;
	}
	char inFile[256];	
	char outFile[256];
    
	long id = pMBegin();
	if(id>0){
		//Set PDF Information
		pMInformation(id,"title","subject","author","keywords","creator","producer");
		
		long fsize=16;
		long fcolor=255;//red
		long position=2;//Top-Center
		long angle=0;
		long xoff=0;
		long yoff=0;
        long asbackground=0;
		//Stamping
		pMWatermark(id,"Watermark",fsize,fcolor,position,angle,xoff,yoff,asbackground);

		//test3 Encrypt
		strcpy(inFile,"test3.pdf");
		strcpy(outFile,"test3Encrypt.pdf");
		pMEncryptPDF(id,inFile,outFile,"user","owner",128,1,0,0);

		pMEnd(id);
	}

	FreeSecurityDll();
	ShowMessage("Encrypt finished!");
}
//---------------------------------------------------------------------------
